<?php

namespace STM\Match\Action;

use \Exception;
use STM\StmFactory;

/**
 * Test class for MatchActionValidator.
 * Generated by PHPUnit on 2012-07-11 at 14:33:26.
 * @group match_action
 */
class MatchActionValidatorTest extends \PHPUnit_Framework_TestCase {

    protected function setUp() {
        MatchActionValidator::init();
    }

    public function testCheck_create() {
        $sport = StmFactory::find()->Sport->findById(1);
        if ($sport) {
            parent::assertTrue(MatchActionValidator::checkCreate(array('match_action' => 'My position 125/*', 'sport' => $sport)));        
        }
        // match_action strlen <2, 50>
        $this->assert_bad_arguments('checkCreate', array('match_action' => 'm', 'sport' => StmFactory::find()->Sport->findById(1)));
        // sports must be instanceof Sport
        $this->assert_bad_arguments('checkCreate', array('match_action' => 'makov', 'sport' => new Exception()));
        // input array must have keys sport and match_action
        $this->assert_bad_arguments('checkCreate', null);
        $this->assert_bad_arguments('checkCreate', array('sport' => 1));
    }

    public function testCheck_update() {        
        // compared object must be set
        $this->assert_bad_arguments('checkUpdate', array('match_action' => 'New action*','sport' => StmFactory::find()->Sport->findById(1)));
        // same as testCheck_create, only values must be different from current value
        foreach (StmFactory::find()->MatchAction->findAll() as $action) {
            $current_name = $action->__toString();
            $current_sport = StmFactory::find()->Sport->findById($action->getIdSport());
            MatchActionValidator::setMatchAction($action);            
            $this->assert_bad_arguments('checkUpdate', array('match_action' => $current_name, 'sport' => $current_sport));
            MatchActionValidator::resetMatchAction();
        }
    }
    
    private function assert_bad_arguments($method, $data) {
        MatchActionValidator::init();
        parent::assertFalse(MatchActionValidator::$method($data));
        MatchActionValidator::init();
    }

}

?>
